<?php
/*
Plugin Name: amr shortcodes
Plugin URI: 
Description: View the shortcodes in use on a site, with links to the pages or posts for editing.
Author: anmari
Version: 1.0
Author URI: http://webdesign.anmari.com

*/

if (!class_exists('amr_shortcodes_plugin_admin')) {
	class amr_shortcodes_plugin_admin {
		var $hook 		= 'amr_shortcodes';
		var $filename	= 'amr_shortcodes/amr_shortcodes.php';
		var $longname	= 'Manage Shortcodes';
		var $shortname	= 'Shortcodes';
		var $optionname = '';
		var $homepage	= '';
		var $parent_slug = 'plugin_listings_menu';
		var $accesslvl	= 'manage_options';
		
		function __construct() {  
			add_action('admin_menu', array(&$this, 'register_settings_page') );	
		}		
		
		function register_settings_page() {
			add_options_page( $this->longname, $this->shortname, $this->accesslvl, $this->hook, array(&$this,'config_page'));
		}		
		
		function plugin_options_url() {
			return admin_url( 'options-general.php?page='.$this->hook );
		}		
 
		function admin_heading($title)  {
		echo '<div class="wrap" >
			<div id="icon-options-general" class="icon32"><br />
			</div>
			<h2><a href="'.$this->plugin_options_url().'">'.$title.'</a> &nbsp; '
			.'<a href="'.add_query_arg('tab','available',$this->plugin_options_url()) .'">'.__('View available shortcodes').'</a></h2>';
	//		<form method="post" action="'
	//		.esc_url($_SERVER['PHP_SELF'])
	//		.'">';
	//		wp_nonce_field($this->hook); /* outputs hidden field */
	//		;
		}

		function admin_subheading($title)  {
			echo '<h2>'.$title.'</h2>';
		}		
		
		function config_page() {
			$this->admin_heading($this->longname); 

			if (empty($_REQUEST['tab']) OR !($_REQUEST['tab'] == 'available'))
				$this->where_shortcode();
			else
				$this->shortcodes_available();
		}		
		
		function shortcodes_available() {
		global $shortcode_tags;
			ksort($shortcode_tags);
			echo '<table class="widefat wp-list-table striped"><thead><tr><th class="manage-column">'
			.__('Shortcode').'</th><th>'.__('Function called').'</th></tr></thead><tbody>';
			foreach ($shortcode_tags as $code => $func) {
				echo '<tr><td>'.$code.'</td><td>'.$func.'</td></tr>';
			}
			echo '</tbody></table>';
		}
		
		function where_shortcode() {
			global $wpdb;

			$pattern = get_shortcode_regex(array('do_widget'));
			//var_dump($pattern);
			
			$results 	= array();
			$query  	= "SELECT * FROM $wpdb->posts WHERE post_status IN ( 'publish', 'future') and post_content LIKE '%[%]%' ORDER BY post_date DESC;" ;
			//$query  	= "SELECT * FROM $wpdb->posts WHERE post_status IN ( 'publish', 'future') and post_content REGEXP '".$pattern."' ORDER BY post_date DESC;" ;
			$results 	= $wpdb->get_results($query);
			
			echo '<table class="widefat wp-list-table striped"><thead><tr><th>';
			_e('Post');
			echo '</th><th>';
			_e('Published');
			echo '</th><th>';
			_e('Shortcodes');
			echo '</th></tr></thead><tbody>';
			foreach($results as $i => $result) {
				echo '<tr><td>';
				edit_post_link($result->post_title.' ',' ',' ',$result->ID);
				echo '</td><td>'.substr($result->post_date,0,11);
				if (!($result->post_status == 'publish')) _e($result->post_status);
				echo '</td><td>';
				preg_match_all("^\[(.*)\]^",$result->post_content,$matches, PREG_PATTERN_ORDER);

				foreach ($matches[0] as $j=> $m) {
					if (!empty($matches[1][$j])) {

						$stext = explode(' ',$matches[1][$j]);
						$short = $stext[0];
						if ( !shortcode_exists( $short ) ) {
							echo ' <a style="color:red;" href="'.
							get_edit_post_link($result->post_title.' ',' ',' ',$result->ID)
							.'" title="Plugin or theme no longer active - edit the post.">';
							_e('X');
							echo '</a>';					
						}
						else echo '<span style="color:green;">'.'&#10004;'.'</span>';
						echo ' '.$m;
						echo '<br />';
					}						
				};
				echo '<td></tr>';
				
			}
			echo '</tbody></table>';
			
		}
	}
}	

function amr_add_action_links ( $links ) {
 $mylinks[] = 
 '<a title="Go" href="'.admin_url( 'options-general.php?page=amr_shortcodes').'">'  . 'Manage Shortcodes</a>';
return array_merge( $links, $mylinks );
}

function amr_shortcodes_load_text() { 
// wp (see l10n.php) will check wp-content/languages/plugins if nothing found in plugin dir
	$result = load_plugin_textdomain( 'amr-shortcodes', false, 
	dirname( plugin_basename( __FILE__ ) ) . '/languages/' );
}

add_action('plugins_loaded'         , 'amr_shortcodes_load_text' );

add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'amr_add_action_links' );

if (is_admin() ) 	$amr_shortcodes_plugin_admin = new amr_shortcodes_plugin_admin();  
?>